////////////////////////////////////////////////////////////////////////////////
//  Rodokmen... Startovn slo 19                                            //
////////////////////////////////////////////////////////////////////////////////
unit RodokmenUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, ExtCtrls;

type
  THlavniF = class(TForm)
    HlMenu: TMainMenu;
    Rodokmen1: TMenuItem;
    Otevt1: TMenuItem;
    Uloit1: TMenuItem;
    Konec1: TMenuItem;
    N1: TMenuItem;
    KmenStrom: TTreeView;
    KmenOtevritDlg: TOpenDialog;
    KmenUlozitDlg: TSaveDialog;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    IDEdit: TEdit;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    Label7: TLabel;
    Edit7: TEdit;
    Label8: TLabel;
    PohlaviSkup: TRadioGroup;
    Button1: TButton;
    Splitter1: TSplitter;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    GroupBox2: TGroupBox;
    DataBox: TListBox;
    Button5: TButton;
    Radit: TCheckBox;
    Pidatosobu1: TMenuItem;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    RadioGroup1: TRadioGroup;
    Button6: TButton;
    procedure Otevt1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure KmenStromChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure KmenStromChange(Sender: TObject; Node: TTreeNode);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure RaditClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Pidatosobu1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    function OtevriKmen(const JmenoSoub:string):boolean;
    procedure UlozKmen(const JmenoSoub:string);
    procedure ObnovStrom;
  end;

  TID=string[10];//pomocne typy
  String32=string[32];
  TPohlavi=(pMuz,pZena{,pHermafrodit});

  TOsoba=record//zaznam o osobe
  	Id:TID;
    Jmeno:string32;
    Prijmeni:string32;
    Pohlavi:TPohlavi;
    Narozeni:string32;
    Umrti:string32;
    Matka:TID;
    Otec:TID;
  end;
  TOsoby=array of TOsoba;

const
  Titulek='Rodokmen - Startovn slo 19';

var
  HlavniF: THlavniF;
  Osoby:TOsoby;
  PocetOsob:integer=0;

implementation

{$R *.DFM}

function SpocitejOsoby(List:TstringList):integer;  // vraci pocet osob v souboru
var
	I:integer;  // slouzi v cyklech
begin
	Result:=0;
	for I:=0 to List.Count-1 do
    if Pos('<OSOBA>',List[i])<>0 then
    	Inc(Result);
end;

function DejPrvniTag(const s:String):string;//no comment
begin
	Result:=copy(S,1,Pos('>',S));
end;

function DejRetMeziTagy(S:String):string;//vraci text prvnim a poslednim tagem
var
  Pozice:integer;
begin
	Pozice:=Pos('>',S)+1;
	Result:=copy(S,Pozice,LastDelimiter('<',S)-Pozice);
end;


procedure VyrobOsoby(List:TStringList);//nacita osoby
var
	I:Integer;
  AktOsoba:integer;
  OdRadku:Integer;//radky, na kterych je osoba

  function VyrobOsobu(OdR,DoR:integer):TOsoba;//nacita osobu
  var
  	I2:integer;
  begin
  	with Result do begin
      Id:='';
      Jmeno:='';
      Prijmeni:='';
      Pohlavi:=pMuz;
      Narozeni:='';
      Umrti:='';
      Matka:='';
      Otec:='';
    end;
  	for I2:=OdR to DoR do begin
      if DejPrvniTag(List[I2])='<ID>' then Result.Id:=DejRetMeziTagy(List[i2]);
      if DejPrvniTag(List[I2])='<JMENO>' then Result.Jmeno:=DejRetMeziTagy(List[i2]);
      if DejPrvniTag(List[I2])='<PRIJMENI>' then Result.Prijmeni:=DejRetMeziTagy(List[i2]);
      if DejPrvniTag(List[I2])='<POHLAVI>' then begin
      	if UpperCase(DejRetMeziTagy(List[i2]))='Z' then
	      	Result.Pohlavi:=pZena
         else
         	Result.Pohlavi:=pMuz;
      end;
      if DejPrvniTag(List[I2])='<NAROZENI>' then Result.Narozeni:=DejRetMeziTagy(List[i2]);
      if DejPrvniTag(List[I2])='<UMRTI>' then Result.Umrti:=DejRetMeziTagy(List[i2]);
      if DejPrvniTag(List[I2])='<MATKA>' then Result.Matka:=DejRetMeziTagy(List[i2]);
      if DejPrvniTag(List[I2])='<OTEC>' then Result.Otec:=DejRetMeziTagy(List[i2]);
    end;
  end;

begin
	OdRadku:=-1;
  AktOsoba:=0;
	for I:=0 to List.Count-1 do begin
    if List[i]='<OSOBA>' then
			OdRadku:=I;
    if ((List[i]='</OSOBA>')and(OdRadku<>-1))or((List[i]='<OSOBA>')and(I<>OdRadku)) then begin
      Osoby[AktOsoba]:=VyrobOsobu(OdRadku+1,I-1);
      Inc(AktOsoba);
      OdRadku:=-1;
    end;
  end;
end;

function UpravTagy(const S:string):string;//odstrani z tagu mezery a taby a da je na velke pismena
var
	TempStr:String;
  I:Integer;
  Hleda:boolean;

begin
	TempStr:=S;
  Hleda:=false;
  I:=1;
	while I<=Length(TempStr) do begin
		case TempStr[i] of
    	'<': Hleda:=true;
      '>': Hleda:=false;
      ' ',#9:
      	if Hleda then begin
  	      Delete(TempStr,i,1);
    	    Dec(i);//pokud neco smazeme, musime snizit pocitadlo
	      end;
    end;
    if Hleda then TempStr[i]:=UpCase(TempStr[i]);
    Inc(I);
  end;
  Result:=TempStr;
end;

function TextVTagu(S:String;Druhy:boolean=false):string;//vraci text v tagu ( '<id>' vrati 'id')
var
	O1,O2:integer;//pozice znaku '<' a '>'
begin
  if Druhy then begin
  	O1:=LastDelimiter('<',S)+1;
	  O2:=LastDelimiter('>',S);
  end else begin
   	O1:=pos('<',S)+1;
	  O2:=pos('>',S);
  end;
  Result:=copy(S,O1,O2-O1);

  while Pos('/',Result)<>0 do
    Delete(Result,Pos('/',Result),1);
end;

procedure THlavniF.ObnovStrom;//obnovi KmenStrom
var
	I:Integer;
  PodNode,HlavniNode:TTreeNode;
  Ukaz:PInteger;

begin
	with KmenStrom.Items do begin
  	BeginUpdate;
    Clear;
    HlavniNode:=Add(nil,'Rodokmen - poet osob: '+intToStr(PocetOsob));
    for I:=0 to PocetOsob-1 do begin
	    PodNode:=AddChild(HlavniNode,Osoby[i].Jmeno+' '+Osoby[i].prijmeni);
      New(Ukaz);
      Ukaz^:=I;
      PodNode.Data:=Ukaz;
    end;
    HlavniNode.Expand(false);
    if Radit.Checked then
	    HlavniNode.AlphaSort;
    EndUpdate;
  end;
end;


//fkce vraci false, pokud nastala chyba. Otevira xml soubor
function THlavniF.OtevriKmen(const JmenoSoub:string):boolean;
var
	I,I2:integer;  // slouzi v cyklech
  Kmen:TStringList;
  Pozice:integer;
 	TempStr:string;

  procedure Chyba(const radek:integer;const hlaska:string);//vyvola chyb. hlasku
  begin
  	TempStr:=format('Soubor: %s; Radek: %d; %s',[UpperCase(JmenoSoub),radek,hlaska]);
  	MessageBox(Handle,Pchar(TempStr),'Chyba',MB_ICONERROR);
    Kmen.Free;
  end;

begin
	Result:=false;

  if not FileExists(JmenoSoub) then begin//existuje soubor
  	Chyba(-1,'Soubor neexistuje');
    Exit;
  end;

  Kmen:=TStringList.Create;
  try
  	Kmen.LoadFromFile(JmenoSoub);//nacteni souboru
  except
    Chyba(-1,'Chyba pi otvrn');
    Exit;
  end;

// *************** uprava souboru ***
  with Kmen do begin
  	for i:=0 to Kmen.Count-1 do begin  // odstranim poc. a konc. mezery a zkontroluji tagy
	  	Strings[i]:=Trim(Strings[i]);
			Strings[i]:=UpravTagy(Strings[i]);
      TempStr:=DejPrvniTag(Strings[i]);
      if (TempStr='<RODOKMEN>')or(TempStr='<OSOBA>')or(TempStr='</OSOBA>')or(TempStr='</RODOKMEN>') then begin
				if TempStr<>Trim(Strings[i]) then begin
        	chyba(i,'Tagy <RODOKMEN>, <OSOBA>, </RODOKMEN>, </OSOBA> mus bt na samostatnm dku');
          Exit;
        end;
      end else begin
	      if TextVTagu(Strings[i])<>TextVTagu(Strings[i],true) then begin
  	      Chyba(i,'Tagy na dku nejsou stejn');
    	    Exit;
      	end;
       end;
    end;

	  I:=IndexOf('');//odstranim prazdne radky
  	while I<>-1 do begin//pouziju i, abych usetril...
	    Kmen.Delete(I);
  	  I:=IndexOf('');
	  end;
  end;
// *************** uprava souboru konec ***

// *************** prevadeni souboru ***
	Pozice:=0;
  if uppercase(Kmen[Pozice])<>'<RODOKMEN>' then begin//mam rad chybove hlasky. dost podstatna chyba
    Chyba(Pozice,'Chyb tag <rodokmen>');
    Exit;
  end;

  PocetOsob:=SpocitejOsoby(Kmen);//spocita a nacte osoby
  SetLength(Osoby,PocetOsob);
 	VyrobOsoby(Kmen);

  for I:=0 to PocetOsob-1 do begin//kontrola na stejne ID
  	for I2:=0 to PocetOsob-1 do begin
    	if (I<>I2)and(Osoby[I].ID=Osoby[I2].ID) then begin
      	Chyba(-1,'Osoby '+Osoby[i].Jmeno+' '+Osoby[i].Prijmeni+' a '+Osoby[i2].Jmeno+' '+Osoby[i2].Prijmeni+' maj stejn ID');
				Exit;
      end;
    end;
  end;
// *************** prevadeni souboru konec ***

// *************** zbrazeni souboru ***

	ObnovStrom;

// *************** zbrazeni souboru konec ***
  Kmen.Free;
  Caption:=Format('%s - [%s]',[Titulek,ExtractFileName(JmenoSoub)]);
  Application.Title:=Caption;
  Result:=true;
end;

procedure THlavniF.Otevt1Click(Sender: TObject);//klik na otevreni
begin
	if KmenOtevritDlg.Execute then begin
  	Screen.Cursor:=crHourGlass;
  	OtevriKmen(KmenOtevritDlg.FileName);
    Screen.Cursor:=crDefault;
  end;
end;

procedure THlavniF.FormCreate(Sender: TObject);
begin
	Caption:=Titulek;						// titulky
  Application.Title:=Titulek; // ^
end;

procedure THlavniF.Konec1Click(Sender: TObject);
begin
	close;
end;

procedure THlavniF.KmenStromChanging(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
begin
	if Node<>nil then// aby to nehazelo errory
		AllowChange:=not(Node.AbsoluteIndex=0);//a aby se neoznacila polozka RODOKMEN
end;

procedure THlavniF.KmenStromChange(Sender: TObject; Node: TTreeNode);//pri zmene oznaceni
var
	index:integer;
begin
	GroupBox1.Visible:=Assigned(KmenStrom.Selected);
  GroupBox2.Visible:=false;
  if Assigned(KmenStrom.Selected) then begin
		Index:=Integer(KmenStrom.Selected.Data^);
    with Osoby[Index] do begin
    	IDEdit.Text:=Id;
      Edit1.Text:=Jmeno;
      Edit2.Text:=Prijmeni;
			PohlaviSkup.ItemIndex:=Integer(Pohlavi);
      Edit4.Text:=Narozeni;
      Edit5.Text:=Umrti;
      Edit6.Text:=Matka;
    	Edit7.Text:=Otec;
    end;
  end;
end;

procedure THlavniF.Button1Click(Sender: TObject);//ulozi zmenenou osobu
var
	index:integer;
begin
	if Assigned(KmenStrom.Selected) then begin
		Index:=Integer(KmenStrom.Selected.Data^);
    with Osoby[Index] do begin
    	Id:=IDEdit.Text;
      Jmeno:=Edit1.Text;
      Prijmeni:=Edit2.Text;
			Pohlavi:=TPohlavi(PohlaviSkup.ItemIndex);
      Narozeni:=Edit4.Text;
      Umrti:=Edit5.Text;
      Matka:=Edit6.Text;
    	Otec:=Edit7.Text;
    end;
    ObnovStrom;
  end;
end;

procedure THlavniF.Button2Click(Sender: TObject);//vymaze osobu
var
	index,i:integer;
begin
	if Assigned(KmenStrom.Selected) then begin
  	if MessageBox(handle,PChar('Jste si opravdu jist, e chcete smazat osobu '+
    Edit1.Text+' '+Edit2.Text+' ???'),'Otzka',MB_ICONQUESTION+MB_YESNO)=idNo then
      Exit;

		Index:=Integer(KmenStrom.Selected.Data^);
    for I:=Index+1 to PocetOsob-1 do
    	Osoby[I-1]:=Osoby[I];
    Dec(PocetOsob);
    SetLength(Osoby,PocetOsob);
    ObnovStrom;
    GroupBox1.Visible:=false;
  end;
end;

procedure THlavniF.Uloit1Click(Sender: TObject);//klik na ulozit
begin
	if KmenUlozitDlg.Execute then begin
  	Screen.Cursor:=crHourGlass;
  	UlozKmen(KmenUlozitDlg.FileName);
    Screen.Cursor:=crDefault;
  end;
end;

procedure THlavniF.UlozKmen(const JmenoSoub:string);//ulozi kmen
var
	Kmen:TStringList;
  I:Integer;

  function VyrobTag(const tag,hodnota:string):string;
  begin
  	if hodnota='' then
    	Result:='    <'+tag+'/>'
		else
    	Result:='    <'+tag+'>'+hodnota+'</'+tag+'>';
  end;

begin
	Kmen:=TStringList.Create;
  with Kmen do begin
    Add('<rodokmen>');
		for i:=0 to PocetOsob-1 do begin
    	Add('  <osoba>');
      with Osoby[i] do begin
        Add(VyrobTag('id',Id));
        Add(VyrobTag('jmeno',Jmeno));
        Add(VyrobTag('prijmeni',Prijmeni));
				if Pohlavi=pMuz then
          Add(VyrobTag('pohlavi','M'))
        else
					Add(VyrobTag('pohlavi','Z'));
        Add(VyrobTag('narozeni',Narozeni));
        Add(VyrobTag('umrti',Umrti));
        Add(VyrobTag('matka',Matka));
        Add(VyrobTag('otec',Otec));
      end;
			Add('  </osoba>');
    end;
    Add('</rodokmen>');
    SaveToFile(JmenoSoub);
  	Free;
  end;
end;

procedure THlavniF.Button3Click(Sender: TObject);//zobrazi deti
var
	I:integer;
  coje:string;
begin
	with DataBox.Items do begin
    Clear;
    if pohlaviSkup.ItemIndex=0 then
    	CoJe:='otec'
    else
    	CoJe:='matka';
    Add(Edit1.Text+' '+Edit2.Text+' je '+coje+' dt:');
    Add('--------------------------------------------');
    for I:=0 to PocetOsob-1 do begin
  		if ((pohlaviSkup.ItemIndex=0)and(Osoby[i].Otec=IDEdit.Text))or
    	((pohlaviSkup.ItemIndex=1)and(Osoby[i].Matka=IDEdit.Text)) then begin
      	Add(Osoby[i].Jmeno+' '+Osoby[I].Prijmeni);
    	end;
	  end;
    if Count>10 then begin
    	Add('--------------------------------------------');
      Add('Vkonn tpek...');//no comment
    end;
    GroupBox2.Visible:=true;
  end;
end;

procedure THlavniF.Button5Click(Sender: TObject);//vraci se z GroupBox2 do GroupBox1
begin
	GroupBox2.Visible:=false;
end;

procedure THlavniF.RaditClick(Sender: TObject);//klik na checkbox razeni
begin
	GroupBox1.Visible:=false;
  GroupBox2.Visible:=false;
  ObnovStrom;
end;

procedure THlavniF.Button4Click(Sender: TObject);//da rodice
var
	I:integer;
begin
  with DataBox.Items do begin
    Clear;
    Add(Edit1.Text+' '+Edit2.Text+':');
    Add('--------------------------------------------');
    for I:=0 to PocetOsob-1 do begin
  		if Osoby[i].Id=Edit6.Text then
      	Add('Otec: '+Osoby[i].Jmeno+' '+Osoby[I].Prijmeni)
      else if Osoby[i].Id=Edit7.Text then
        Add('Matka: '+Osoby[i].Jmeno+' '+Osoby[I].Prijmeni)
	  end;
    if Count>4 then begin
    	Add('--------------------------------------------');
      Add('Ehhh???');//no comment
    end;
    GroupBox2.Visible:=true;
  end;
end;

procedure THlavniF.Pidatosobu1Click(Sender: TObject);//prida osobu
begin
  KmenStrom.Selected:=nil;
  GroupBox3.Visible:=true;
  Edit8.Text:='';
  Edit9.Text:='';
  Edit10.Text:='';
  Edit11.Text:='';
  Edit12.Text:='';
  Edit13.Text:='';
  RadioGroup1.ItemIndex:=0;
  ActiveControl:=Edit8;
end;

procedure THlavniF.Button6Click(Sender: TObject);
begin
	Randomize;
	GroupBox3.Visible:=true;
  Inc(PocetOsob);
  SetLength(Osoby,PocetOsob);
  with Osoby[PocetOsob-1] do begin
    Jmeno:=Edit8.Text;
    Prijmeni:=Edit9.Text;
    Pohlavi:=tPohlavi(RadioGroup1.ItemIndex);
    Narozeni:=Edit10.Text;
    Umrti:=Edit11.Text;
    Matka:=Edit12.Text;
    Otec:=Edit13.Text;
    ID:=IntTOStr(Random(MaxInt));
  end;
end;

end.
